﻿var _currentBattIcon;
var _currentOnPower;
var _currentCharging;
var _currentPercentString;
var _currentTimeString;
var _wmiInterface;
var _imgBatt;
var _imgPower;
var _txtPercentage;
var _txtTime;
var _txtPercentageLarge;
//Will hold instance of the GadgetBuilder to load/unload .NET assemblies. See GadgetInterop.js
var _interop;
//Will hold .NET instance of the BatteryGauge.TimeRemaining object.
var _timeRemaining;

function Init()
{
  _currentBattIcon = -1;
  _currentOnPower = false;
  _currentCharging = false;
  _currentPercentString = " ";
  _currentTimeString = " ";
  _wmiInterface = GetObject("winmgmts:{impersonationLevel=impersonate}!//./root/cimv2");
  _imgBatt = background.addImageObject("", 0, 0);
  _imgPower = background.addImageObject("", 80, 20);
  _txtPercentage = background.addTextObject(" ", "Arial", 18, "White", 45, 16);
  _txtPercentage.width = 60;
  _txtPercentage.align = 1;
  _txtTime = background.addTextObject(" ", "Segoe UI", 18, "White", 45, 36);
  _txtTime.width = 60;
  _txtTime.align = 1;
  _txtPercentageLarge = background.addTextObject(" ", "Segoe UI", 20, "White", 45, 23);
  _txtPercentageLarge.width = 60;
  _txtPercentageLarge.align = 1;
  // Initialize the _interop object and acquire the _timeRemaining .NET assembly reference.
  _interop = new GadgetBuilder();
  _interop.Initialize();
  _timeRemaining = _interop.LoadType(System.Gadget.path + "\\bin\\BatteryGauge.dll", "BatteryGauge.TimeRemaining");
  Update();
}

function Dispose()
{
  //Clean up by gracefully disposing the COM object holding the TimeRemaining assembly.
  _interop.UnloadType(_timeRemaining);
  _timeRemaining = null;
  _interop = null;
}

function FixedPercent(percent)
{
  if (percent === null)
  {
    return "0"; //0
  }
  if (percent <= 0)
  {
    return "0"; //0
  }
  if (percent > 100)
  {
    return "n/a"; //(100) sem bateria
  }
  return percent;
}

function Update()
{
  var percent = FixedPercent(System.Machine.PowerStatus.batteryPercentRemaining);
  var percentString;
  var timeString;
  var battIcon;
  var onPower = false;
  var charging = false;

  if (percent >= 90)
  {
    battIcon = 8;
  }
  else if (percent >= 80)
  {
    battIcon = 7;
  }
  else if (percent >= 70)
  {
    battIcon = 6;
  }
  else if (percent >= 60)
  {
    battIcon = 5;
  }
  else if (percent >= 50)
  {
    battIcon = 4;
  }
  else if (percent >= 30)
  {
    battIcon = 3;
  }
  else if (percent > 10)
  {
    battIcon = 2;
  }
  else if (percent > 7)
  {
    battIcon = 1;
  }
  else
  {
    battIcon = 0;
  }

if (percent == "n/a"){battIcon = "na";} //no battery


  percentString = percent + "%";

if(percent=="n/a"){percentString=" "} //no battery, remove percent.


  if (System.Machine.PowerStatus.isBatteryCharging)
  {
    timeString = " ";
    charging = true;
  }
  else if (System.Machine.PowerStatus.isPowerLineConnected)
  {
    timeString = " ";
    onPower = true;
  }
  else
  {
    timeString = _timeRemaining.TimeRemainingString;
    if (timeString == "")
    {
      timeString = " ";
    }
  }
  if (_currentBattIcon !=  battIcon)
  {
    _imgBatt.src = "icons/battery_" + battIcon + ".png";
    _currentBattIcon = battIcon;
  }
  if (_currentTimeString != timeString)
  {
    if (_currentTimeString == " ")
    {
      //If transitioning to having a time string present, clear the large percent text and force the percent text to update below.
      _txtPercentageLarge.value = " ";
      _currentPercentString = " ";
    }
    if (timeString == " ")
    {
      //If transitioning from having a time string present, clear the small percent text and force the percent text to update below.
      _txtPercentage.value = " ";
      _currentPercentString = " ";
    }
    _txtTime.value = timeString;
    _currentTimeString = timeString;
  }
  if (_currentPercentString != percentString)
  {
    if (_currentTimeString == " ")
    {
      _txtPercentageLarge.value = percentString;
    }
    else
    {
      _txtPercentage.value = percentString;
    }
    _currentPercentString = percentString;
  }
  if ((_currentOnPower != onPower) || (_currentCharging != charging))
  {
    _currentOnPower = onPower;
    _currentCharging = charging;
    if (charging)
    {
      _imgPower.src = "icons/power_charging.png";
    }
    else if (onPower)
    {
      _imgPower.src = "icons/power_ac.png";
    }
    else
    {
      _imgPower.src = "icons/power_blank.png";
    }
  }
  setTimeout(Update, 5000);
}